Subject: bug#26905: closed (Re: bug#26905: [PATCH] Show tooltip on correct screen (bug#26905))

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 20 May 2017 23:17:02 +0000

Your bug report

#26905: 25.2: MacOS: tooltips show in wrong display

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
26905: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=26905
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#26905: [PATCH] Show tooltip on correct screen (bug#26905)
From: Alan Third <[email-masked]>
To: "Charles A. Roelli" <[email-masked]>
Cc: [email-masked]
Date: Sun, 21 May 2017 00:15:59 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

"Charles A. Roelli" <[email-masked]> writes:

> Works fine for me too! Thanks for coming up with this fix.
>> 
>> Here’s my go at this. It seems to work OK on single and multi‐monitor
>> setups in macOS, and in GNUstep in single monitor (I can’t test it
>> multi‐monitor).

Pushed to master.

-- 
Alan Third

Subject: 25.2: MacOS: tooltips show in wrong display
From: "Charles A. Roelli" <[email-masked]>
To: [email-masked]
Date: Sat, 13 May 2017 09:43:27 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Continuing from bug#26816 
(https://debbugs.gnu.org/cgi/bugreport.cgi?bug=26816#32):

On 11/05/2017 23:43, Alan Third wrote:

>> This now reminds me of a related problem, though: with Emacs 25.2 (or in
>> Emacs 26, with the above change applied to NS_PARENT_WINDOW_TOP_POS(f)),
>> tooltips originating from an area with a help-echo property (like "Lisp
>> Interaction" in the mode line in emacs -Q) in a frame on the secondary
>> monitor actually show up in the primary monitor instead -- as if the tooltip
>> frame is constrained to having a positive x-coordinate only.  I haven't
>> found where it happens, but I guess the cause is similar.
>
> Look at compute_tip_xy in nsfns.m. It moves tooltips into the positive
> screen space. I’ve not managed to get to grips with this code yet.
>
> I think what we want is for it to try to keep the tooltip on one
> screen, so it’s not spanning two monitors, but allow it to go into
> negative space.
>
> Perhaps this should be a separate bug report.

"Primary" and "secondary" monitors are as follows:

(display-monitor-attributes-list) =>

(((name . "Color LCD")
   (geometry 0 0 1280 800)
   (workarea 0 22 1280 714)
   (mm-size 290 180)
   (frames #<frame emacs-devel 0x105044260> #<frame *Backtrace* 
0x1199eca10> #<frame *vc-diff* 0x117dc82b8> #<frame nsterm.m 
0x121c49ad8> #<frame *shell* 0x119adf830> #<frame  *Minibuf-1* 0x119b33030>)
   (source . "NS"))
  ((name . "DELL 2007WFP")
   (geometry -1050 -880 1050 1680)
   (workarea -1050 -880 1050 1680)
   (mm-size 430 270)
   (frames #<frame nsterm.h 0x117c83fd0>)
   (source . "NS")))